/* LOADBMP (Windows 3.0 Bitmap Files, keine OS/2 Bitmaps) */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <windows.h>
#include "dib.h"

#pragma pack(1)

DIB *LoadBMP(char filename[])
{
    FILE *f;
    int count,value,y,i;
    char huge *ptr;
    BOOL even;
    BITMAPFILEHEADER bmfh;
    BITMAPINFOHEADER bmih;
    long size,skew;
    DIB *dib;
    char name[81];

    AnsiToOem(filename,name);
    f=fopen(name,"rb");
    dib=NULL;
    if(f)
    {
        if(fread((void *)&bmfh,sizeof(bmfh),1,f)==1
        && fread((void *)&bmih,sizeof(bmih),1,f)==1
        && bmfh.bfType==0x4D42
        && bmih.biSize==40L
        && (dib=malloc(sizeof(DIB)+(1<<bmih.biBitCount)*sizeof(RGBQUAD)))!=NULL )
        {
            skew=((bmih.biWidth*bmih.biBitCount+31L)/32)*4;
            size=skew*bmih.biHeight;
            if(bmih.biClrUsed==0) bmih.biClrUsed=(short)(1<<bmih.biBitCount);
            memcpy(&dib->bmi.bmiHeader,&bmih,sizeof(bmih));
            fseek(f,sizeof(bmfh)+bmih.biSize,0);
            dib->bmi.bmiHeader.biCompression=BI_RGB;
            dib->bmi.bmiHeader.biSizeImage=size;
            if(fread((void *)&dib->bmi.bmiColors,sizeof(RGBQUAD),(size_t)bmih.biClrUsed,f)==(size_t)bmih.biClrUsed
            && (ptr=dib->data=GlobalLock(GlobalAlloc(GMEM_ZEROINIT|GMEM_MOVEABLE,size)))!=NULL)
            {
                y=0;
                switch(bmih.biCompression)
                {
                case BI_RLE4:
                    even=TRUE;
                    while(ptr<dib->data+size)
                    {
                        if(even)
                        {
                            count=(unsigned char)getc(f);
                            value=(unsigned char)getc(f);
                            if(count>0)
                            {
                                while(count>1) { *ptr++=value; count-=2; }
                                if(count) { *ptr=value&0xF0; even=FALSE; }
                            }
                            else if(value>2)
                            {
                                for(count=0;count<value/2;count++) *ptr++=getc(f);
                                if(value&1) { *ptr=getc(f)&0xF0; even=FALSE; }
                                if((value+1)&2) getc(f); /* alignment */
                            }
                            else if(value==0)
                            {
                                ptr=dib->data+(++y)*skew;
                            }
                            else if(value==1)
                            {
                                break;
                            }
                            else 
                            {
                                ptr+=(value=(unsigned char)getc(f))>>1;
                                if(value&1) even=FALSE;
                                ptr+=(count=(unsigned char)getc(f))*skew;
                                y+=count;
                            }
                        }
                        else
                        {
                            count=(unsigned char)getc(f);
                            value=(unsigned char)getc(f);
                            if(count)
                            {
                                value=((value>>4)&0x0F)|((value<<4)&0xF0);
                                *ptr++|=value&0x0F; count--;
                                while(count>1) { *ptr++=value; count-=2; }
                                if(count) *ptr=value&0xF0; else even=TRUE;
                            }
                            else if(value>2)
                            {
                                for(count=0;count<value/2;count++)
                                {
                                    i=getc(f);
                                    *ptr++|=i>>4;
                                    *ptr=i<<4;
                                }
                                if(value&1) { *ptr++|=getc(f)>>4; even=TRUE; }
                                if((value+1)&2) getc(f); /* alignment */
                            }
                            else if(value==0)
                            {
                                ptr=dib->data+(++y)*skew;
                                even=TRUE;
                            }
                            else if(value==1)
                            {
                                break;
                            }
                            else 
                            {
                                ptr+=(value=(unsigned char)getc(f))>>1;
                                if(value&1) even=TRUE;
                                ptr+=(count=(unsigned char)getc(f))*skew;
                                y+=count;
                            }
                        }
                    }
                    break;
                case BI_RLE8:
                    while(ptr<dib->data+size)
                    {
                        count=(unsigned char)getc(f);
                        value=(unsigned char)getc(f);
                        if(count>0)
                        {
                            while(count-->0) *ptr++=value;
                        }
                        else if(value>2)
                        {
                            for(count=0;count<value;count++) *ptr++=getc(f);
                            if(value&1) getc(f); /* alignment */
                        }
                        else if(value==0) /* Ende der Bildzeile */
                        {
                            ptr=dib->data+(++y)*skew;
                        }
                        else if(value==1) /* Ende der Bitmap */
                        {
                            break;
                        }
                        else /* Delta */
                        {
                            ptr+=(unsigned char)getc(f);
                            ptr+=(count=(unsigned char)getc(f))*skew;
                            y+=count;
                        }
                    }
                    break;
                default:
                    while(ptr<dib->data+size) *ptr++=getc(f);
                }
            }
            else
            {
                message("LoadBMP: memory problems");
                free(dib);
                dib=NULL;
            }
        }
        else
        {
            message("File %s\nis not a valid BMP file",filename);
        }
        fclose(f);
    }
    else
    {
        message("File %s\ndoes not exist",filename);
    }
    return dib;
}
