/* LOADPCX */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <windows.h>
#include "dib.h"

#pragma pack(1)

DIB *LoadDTA(char filename[])
{
    typedef struct pcxhead
    {
        BYTE bManID;
        BYTE bHver;
        BYTE bEncod;
        BYTE bBitPix;
        short iX1;
        short iY1;
        short iX2;
        short iY2;
        short iHres;
        short iVres;
        BYTE abPal[48];
        BYTE bVmode;
        BYTE bNplanes;
        short iBytesPerBitPlane;
        BYTE abFill[60];
    }
    PCXHEAD;
    static RGBQUAD defaultPalette[]=
    {
        {0x00,0x00,0x00,0},
        {0x00,0x00,0x80,0},
        {0x00,0x80,0x00,0},
        {0x00,0x80,0x80,0},
        {0x80,0x00,0x00,0},
        {0x80,0x00,0x80,0},
        {0x80,0x80,0x00,0},
        {0x80,0x80,0x80,0},
        {0xC0,0xC0,0xC0,0},
        {0x00,0x00,0xFF,0},
        {0x00,0xFF,0x00,0},
        {0x00,0xFF,0xFF,0},
        {0xFF,0x00,0x00,0},
        {0xFF,0x00,0xFF,0},
        {0xFF,0xFF,0x00,0},
        {0xFF,0xFF,0xFF,0}
    };
    PCXHEAD header;
    BYTE count;
    BYTE value;
    DIB *dib;
    char huge *ptr;
    FILE *f;
    int i,n,j;
    short colors;
    DWORD skew;
    char name[81];

    AnsiToOem(filename,name);
    f=fopen(name,"rb");
    dib=NULL;
    if(f)
    {
	if(fread(&header,sizeof(header),1,f)==1)
        {
            colors=256;
            dib=(DIB *)malloc(sizeof(DIB)+colors*sizeof(RGBQUAD));
            if(dib)
            {
                memset(dib,0,sizeof(DIB));
                if(colors>0&&colors<=16)
                {
                    memcpy(dib->bmi.bmiColors,defaultPalette+(16-colors),colors*sizeof(RGBQUAD));
                    memcpy(dib->bmi.bmiColors,defaultPalette,1*sizeof(RGBQUAD));
                }
                dib->bmi.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
                dib->bmi.bmiHeader.biWidth=header.iX2+1;
                dib->bmi.bmiHeader.biHeight=header.iY2+1;
                dib->bmi.bmiHeader.biPlanes=1;
                dib->bmi.bmiHeader.biBitCount=8;
                if(dib->bmi.bmiHeader.biBitCount<=1) dib->bmi.bmiHeader.biBitCount=1;
                else if(dib->bmi.bmiHeader.biBitCount<=4) dib->bmi.bmiHeader.biBitCount=4;
                else if(dib->bmi.bmiHeader.biBitCount<=8) dib->bmi.bmiHeader.biBitCount=8;
                else dib->bmi.bmiHeader.biBitCount=24;
                dib->bmi.bmiHeader.biCompression=BI_RGB;
                dib->bmi.bmiHeader.biClrUsed=colors;
                skew=((dib->bmi.bmiHeader.biWidth*dib->bmi.bmiHeader.biBitCount+31UL)/32UL)*4UL;
                dib->bmi.bmiHeader.biSizeImage=skew*dib->bmi.bmiHeader.biHeight;
                if((dib->data=GlobalLock(GlobalAlloc(GMEM_MOVEABLE|GMEM_ZEROINIT,dib->bmi.bmiHeader.biSizeImage)))!=NULL)
                {
                    count=0;
                    for(j=(int)dib->bmi.bmiHeader.biHeight;j-->0;)
                    {
                        for(n=0;n<1;n++)
                        {
                            ptr=dib->data+skew*j;
                            if(colors==0) ptr+=3*(2-n);
                            for(i=0;i<=header.iX2;i++)
                            {
                                if(count==0)
                                {
                                    value=getc(f);
                                    if(value>=192)
                                    {
                                        count=(value&0x3F)-1;
                                        value=getc(f);
                                    }
                                }
                                else count--;
                                *ptr++=value;
                            }
                        }
                    }
                    if(getc(f)==12)
                    {
                        for(i=0;i<colors;i++)
                        {
                            dib->bmi.bmiColors[i].rgbRed=getc(f);
                            dib->bmi.bmiColors[i].rgbGreen=getc(f);
                            dib->bmi.bmiColors[i].rgbBlue=getc(f);
                            dib->bmi.bmiColors[i].rgbReserved=0;
                        }
                    }
                    else for(i=0;i<colors;i++)
                    {
                        dib->bmi.bmiColors[i].rgbRed=i;
                        dib->bmi.bmiColors[i].rgbGreen=i;
                        dib->bmi.bmiColors[i].rgbBlue=i;
                        dib->bmi.bmiColors[i].rgbReserved=0;
                    }
                }
                else
                {
                    free(dib);
                    dib=NULL;
                    message("GlobalAlloc failed");
                }
            }
            else message("malloc failed");
        }
        else message("Can not read");
        fclose(f);
    }
    else message("File not found");
    return dib;
}
