/* LOADFLT */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <windows.h>
#include "dib.h"

#pragma pack(1)

typedef struct
{
    HANDLE hmf;	/* Global memory handle to metafile */
    RECT bbox;	/* bounding rect in metafile units */
    short inch;	/* metafile units per inch */
}
PICTINFO, far *LPPICTINFO;

DIB *LoadFLT(char filename[],HWND wnd,HANDLE hInst,char importfilter[])
{
    typedef struct
    {
	unsigned slippery:1;
	unsigned write:1;
	unsigned unnamend:1;
	unsigned linked:1;
	unsigned mark:1;
	unsigned unused:11; /* BorlandC */
	DWORD fType;
	short handle;
	char fullName[124];
	DWORD filePos;
    }
    FILESPEC;

    char buffer[256];
    FILESPEC fs;
    HANDLE lib;
    HANDLE hPrefMem;
    HANDLE hFileTypes;
    WORD result;
    WORD (FAR PASCAL *GetFilterInfo)(int idVersion,LPSTR szIni,HANDLE FAR *hPrevMem,HANDLE FAR *hFileTypes);
    WORD (FAR PASCAL *ImportGR)(HDC hdc,FILESPEC FAR *fs,PICTINFO FAR *pi,HANDLE hPrevMem);
    VOID (FAR PASCAL *GetFilterPref)(HANDLE hInst,HWND parent,HANDLE hPrefMem,WORD flags);
    HDC dc;
    DWORD skew;
    HBITMAP bm;
    PICTINFO picture;
    int colors,width,height;
    DIB *dib;

    dib=NULL;
    picture.hmf=0;
    lib=LoadLibrary(importfilter);
    if(lib>=32)
    {
	(FARPROC)GetFilterInfo=GetProcAddress(lib,"GETFILTERINFO");
	if(GetFilterInfo)
	{
	    hPrefMem=hFileTypes=0;
	    result=GetFilterInfo(0,NULL,&hPrefMem,&hFileTypes);
	    if(result==2)
	    {
		(FARPROC)GetFilterPref=GetProcAddress(lib,"GETFILTERPREF");
		if(GetFilterPref) GetFilterPref(hInst,wnd,hPrefMem,0);
		(FARPROC)ImportGR=GetProcAddress(lib,"IMPORTGR");
		if(ImportGR)
		{
		    memset(&fs,0,sizeof(fs));
		    strcpy(fs.fullName,filename);
		    dc=CreateCompatibleDC(0);
	            if(dc)
	            {
		        result=ImportGR(dc,(void far *)&fs,(void far *)&picture,hPrefMem);
			if(result)
		        {
			    sprintf(buffer,
			      "Das Ladeprogramm\n"
			      "%s\n"
			      "meldet Fehler %d bei\n"
			      "%s",importfilter,result,filename);
			    message(buffer);
		        }
		        else 
		        {
			    width=MulDiv(picture.bbox.right-picture.bbox.left,GetDeviceCaps(dc,LOGPIXELSX),picture.inch);
			    height=MulDiv(picture.bbox.bottom-picture.bbox.top,GetDeviceCaps(dc,LOGPIXELSY),picture.inch);
			    bm=CreateBitmap(width,height,GetDeviceCaps(dc,PLANES),GetDeviceCaps(dc,BITSPIXEL),NULL);
			    if(bm)
			    {
				bm=SelectObject(dc,bm);
				BitBlt(dc,0,0,width,height,0,0,0,WHITENESS);
				SetMapMode(dc,MM_ANISOTROPIC);
				SetViewportOrg(dc,0,0);
				SetViewportExt(dc,width,height);
				PlayMetaFile(dc,picture.hmf);
				bm=SelectObject(dc,bm);
				colors=GetDeviceCaps(dc,PLANES)*GetDeviceCaps(dc,BITSPIXEL);
				if(colors>8) colors=0;
				else if(colors>4) colors=8;
				else if(colors>1) colors=4;
				else colors=1;
				dib=(DIB *)malloc(sizeof(DIB)+(1<<colors)*sizeof(RGBQUAD));
				if(dib)
				{
				    memset(dib,0,sizeof(DIB));
				    dib->bmi.bmiHeader.biSize=40;
				    dib->bmi.bmiHeader.biWidth=width;
				    dib->bmi.bmiHeader.biHeight=height;
				    dib->bmi.bmiHeader.biPlanes=1;
				    dib->bmi.bmiHeader.biBitCount=colors;
				    dib->bmi.bmiHeader.biCompression=BI_RGB;
				    skew=((dib->bmi.bmiHeader.biWidth*dib->bmi.bmiHeader.biBitCount+31UL)/32UL)*4UL;
				    dib->bmi.bmiHeader.biSizeImage=skew*dib->bmi.bmiHeader.biHeight;
				    if((dib->data=GlobalLock(GlobalAlloc(GMEM_MOVEABLE|GMEM_ZEROINIT,dib->bmi.bmiHeader.biSizeImage)))!=NULL)
				    {
					GetDIBits(dc,bm,0,height,dib->data,&dib->bmi,DIB_RGB_COLORS);
				    }
				    else
				    {
					free(dib);
					dib=NULL;
					message("GlobalAlloc failed");
				    }
				}
				else
				{
				    message("malloc failed");
				}
				DeleteObject(bm);
			    }
			    else
			    {
				message("CreateBitmap failed");
			    }
			    if(picture.hmf) DeleteMetaFile(picture.hmf);
			}
			DeleteDC(dc);
		    }
		}
	    }
	    else
	    {
		sprintf(buffer,"%s\nist kein Ladeprogramm\nfr Zeichnungen.",importfilter);
		message(buffer);
	    }
	    if(hPrefMem) GlobalFree(hPrefMem);
	    if(hFileTypes) GlobalFree(hFileTypes);
	}
	FreeLibrary(lib);
    }
    else
    {
	sprintf(buffer,"Ladefehler %d bei\n%s",lib,importfilter);
	message(buffer);
    }
    return dib;
}
