/* LOADIFF */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <windows.h>
#include "dib.h"

#pragma pack(1)

void fix(void *b,char *c)
{
    char temp;
    union { int one; char two[2]; } test;

    test.one=1;
    if(test.two[0]==1)
    {
        while(*c!='\0')
        {
            if(*c=='L')
            {
                temp=((char *)b)[0]; ((char *)b)[0]=((char *)b)[3]; ((char *)b)[3]=temp;
                temp=((char *)b)[1]; ((char *)b)[1]=((char *)b)[2]; ((char *)b)[2]=temp;
                ((char *)b)+=4;
            }
            else if(*c=='W')
            {
                temp=((char *)b)[0]; ((char *)b)[0]=((char *)b)[1]; ((char *)b)[1]=temp;
                ((char *)b)+=2;
            }
            else
            {
                ((char *)b)++;
            }
            c++;
        }
    }
}

DIB *LoadIFF(char filename[])
{
    typedef struct form
    {
        char form[4]; /* FORM */
        long formlen; /* ohne die ersten 8 Bytes */
        char ilbm[4]; /* ILBM */
    }
    FORM;
    typedef struct bmhd
    {
        char bmhd[4]; /* BMHD */
        long bmhdlen; /* 20 */
        short pictwidth; /* Bildbreite in Bildpunkten */
        short pictheight; /* Bildbreite in Bildzeilen */
        short xorg; /* Pos. der linken Ecke des Bildes auf dem Bildschirm */
        short yorg; /* Pos. der oberen Kante des Bildes auf dem Bildschirm */
        unsigned char planes; /* Anzahl der Farbebenen */
        unsigned char mask; /* Anzahl der Maskenebenen */
        unsigned char compression; /* 0=Keine, 1=RunLen */
        unsigned char pad; /* 0 */
        short transparent; /* Welche Farbe gilt bei BitBlt als transparent */
        unsigned char xaspect; /* relative Breite eines Bildpunktes */
        unsigned char yaspect; /* relative Hoehe einer Bildzeile */
        short pagewidth; /* Breite des Bildschirms von dem das Bild stammt, in Bildpunkten */
        short pageheight; /* Hoehe des Bildschirms von dem das Bild stammt, in Bildzeilen */
    }
    BMHD;
    typedef struct body
    {
        char body[4]; /* BODY */
        long bodylen; /* ohne die ersten 8 Bytes */
    }
    BODY;

    long pos;
    static BMHD bmhd;
    static FORM form;
    static BODY body;
    int x;
    int y;
    int p;
    unsigned char mask;
    int i;
    int count;
    BYTE value;
    char huge *ptr;
    FILE *f;
    DIB *dib;
    int bitsperpixel,colors;
    DWORD skew;
    static BYTE bits[4][4]=
    {
        {0x00,0x01,0x10,0x11},
        {0x00,0x02,0x20,0x22},
        {0x00,0x04,0x40,0x44},
        {0x00,0x08,0x80,0x88},
    };
    char name[81];

    AnsiToOem(filename,name);
    f=fopen(name,"rb");
    dib=NULL;
    if(f)
    {
        fread(&form,sizeof(FORM),1,f);
        fix(&form,"BBBBL");
        if(memcmp(form.form,"FORM",4)==0&&memcmp(form.ilbm,"ILBM",4)==0)
        {
            while(fread(&body,sizeof(BODY),1,f)==1)
            {
                pos=ftell(f);
                fix(&body,"BBBBL");
                if(memcmp(body.body,"BMHD",4)==0)
                {
                    memcpy((void *)&bmhd,(void *)&body,sizeof(BODY));
                    fread((void *)&bmhd.pictwidth,(int)bmhd.bmhdlen,1,f);
                    fix((char *)&bmhd,"BBBBBBBBWWWWBBBBWBBWW");
                    if(bmhd.planes==1)
                    {
                        bitsperpixel=1;
                    }
                    else if(bmhd.planes<=4)
                    {
                        bitsperpixel=4;
                    }
                    else if(bmhd.planes<=8)
                    {
                        bitsperpixel=8;
                    }
                    else /* bmhd.planes<=24 hoffentlich */
                    {
                        bitsperpixel=24;
                    }
                    colors=1<<bitsperpixel; /* bei 24 bit kommt 0 raus! Super! */
                    dib=(DIB *)malloc(sizeof(DIB)+colors*sizeof(RGBQUAD));
                    if(dib)
                    {
                        memset(dib,0,sizeof(DIB));
                        dib->bmi.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
                        dib->bmi.bmiHeader.biWidth=bmhd.pictwidth;
                        dib->bmi.bmiHeader.biHeight=bmhd.pictheight;
                        dib->bmi.bmiHeader.biPlanes=1;
                        dib->bmi.bmiHeader.biBitCount=bitsperpixel;
                        dib->bmi.bmiHeader.biCompression=BI_RGB;
                        dib->bmi.bmiHeader.biClrUsed=colors;
                        skew=((dib->bmi.bmiHeader.biWidth*dib->bmi.bmiHeader.biBitCount+31)/32)*4;
                        dib->bmi.bmiHeader.biSizeImage=(long)skew*dib->bmi.bmiHeader.biHeight;
                        if((dib->data=GlobalLock(GlobalAlloc(GMEM_MOVEABLE|GMEM_ZEROINIT,dib->bmi.bmiHeader.biSizeImage)))==NULL)
                        {
                            free(dib);
                            dib=NULL;
                        }
                    }
                }
                else if(memcmp(body.body,"CMAP",4)==0&&dib)
                {
                    for(i=0;i<colors&&i<body.bodylen/3;i++)
                    {
                        dib->bmi.bmiColors[i].rgbRed=getc(f);
                        dib->bmi.bmiColors[i].rgbGreen=getc(f);
                        dib->bmi.bmiColors[i].rgbBlue=getc(f);
                        dib->bmi.bmiColors[i].rgbReserved=0;
                    }
                }
                else if(memcmp(body.body,"BODY",4)==0&&dib->data)
                {
                    count=0;
                    for(y=bmhd.pictheight;y-->0;)
                    {
                        for(mask=1,p=0;p<(int)bmhd.planes;p++,mask<<=1)
                        {
                            ptr=dib->data+(long)skew*y+p/8;
                            /* pictwidth muss Vielfaches von 16 sein */
                            for(x=0;x<bmhd.pictwidth;x+=8)
                            {
                                if(bmhd.compression==0)
                                {
                                    value=getc(f);
                                }
                                else if(count<0)
                                {
                                    count++;
                                }
                                else if(count>0)
                                {
                                    count--;
                                    value=getc(f);
                                }
                                else
                                {
                                    count=(signed char)(getc(f));
                                    value=getc(f);
                                }
                                if(dib->bmi.bmiHeader.biBitCount==1)
                                {
                                    *ptr++=value;
                                }
                                else if(dib->bmi.bmiHeader.biBitCount==4)
                                {
                                    *ptr++|=bits[p][(value>>6)&3];
                                    *ptr++|=bits[p][(value>>4)&3];
                                    *ptr++|=bits[p][(value>>2)&3];
                                    *ptr++|=bits[p][value&3];
                                }
                                else if(dib->bmi.bmiHeader.biBitCount==8)
                                {
                                    if(value&0x80) *ptr|=mask;
                                    ptr++;
                                    if(value&0x40) *ptr|=mask;
                                    ptr++;
                                    if(value&0x20) *ptr|=mask;
                                    ptr++;
                                    if(value&0x10) *ptr|=mask;
                                    ptr++;
                                    if(value&0x08) *ptr|=mask;
                                    ptr++;
                                    if(value&0x04) *ptr|=mask;
                                    ptr++;
                                    if(value&0x02) *ptr|=mask;
                                    ptr++;
                                    if(value&0x01) *ptr|=mask;
                                    ptr++;
                                }
                                else /* dib->bmi.bmiHeader.biBitCount==24 */
                                {
                                    if(value&0x80) *ptr|=mask;
                                    ptr+=3;
                                    if(value&0x40) *ptr|=mask;
                                    ptr+=3;
                                    if(value&0x20) *ptr|=mask;
                                    ptr+=3;
                                    if(value&0x10) *ptr|=mask;
                                    ptr+=3;
                                    if(value&0x08) *ptr|=mask;
                                    ptr+=3;
                                    if(value&0x04) *ptr|=mask;
                                    ptr+=3;
                                    if(value&0x02) *ptr|=mask;
                                    ptr+=3;
                                    if(value&0x01) *ptr|=mask;
                                    ptr+=3;
                                }
                            }
                        }
                    }
                    break;
                }
                fseek(f,pos+body.bodylen,SEEK_SET);
            }
        }
        fclose(f);
    }
    return dib;
}
