/* LOADPCX */

/* PC Paintbrush PCX Bildateien und Microsoft WORD Capture SCR Bilddateien */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <windows.h>
#include "dib.h"

#pragma pack(1)

DIB *LoadPCX(char filename[])
{
    typedef struct pcxhead
    {
        unsigned char manid;
        unsigned char version;
        unsigned char encoding;
        unsigned char bitperpix;
        short left;
        short top;
        short right;
        short bottom;
        short screenwidth;
        short screenheight;
        unsigned char palette[48];
        unsigned char videomode;
        unsigned char planes;
        short skew;
        unsigned char unused[60];
    }
    PCXHEAD;
    static RGBQUAD defaultPalette[]=
    {
        {0x00,0x00,0x00,0},
        {0x00,0x00,0x80,0},
        {0x00,0x80,0x00,0},
        {0x00,0x80,0x80,0},
        {0x80,0x00,0x00,0},
        {0x80,0x00,0x80,0},
        {0x80,0x80,0x00,0},
        {0x80,0x80,0x80,0},
        {0xC0,0xC0,0xC0,0},
        {0x00,0x00,0xFF,0},
        {0x00,0xFF,0x00,0},
        {0x00,0xFF,0xFF,0},
        {0xFF,0x00,0x00,0},
        {0xFF,0x00,0xFF,0},
        {0xFF,0xFF,0x00,0},
        {0xFF,0xFF,0xFF,0}
    };
    PCXHEAD header;
    unsigned char count;
    unsigned char value;
    DIB *dib;
    char huge *ptr;
    FILE *f;
    int i,n,j;
    short colors;
    DWORD skew;
    static unsigned char bits[4][4]=
    {
        {0x00,0x01,0x10,0x11},
        {0x00,0x02,0x20,0x22},
        {0x00,0x04,0x40,0x44},
        {0x00,0x08,0x80,0x88}
    };
    static unsigned char mask[8]={0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};
    char name[81];

    AnsiToOem(filename,name);
    f=fopen(name,"rb");
    dib=NULL;
    if(f)
    {
	if(fread(&header,sizeof(header),1,f)==1&&(header.manid==10||header.manid==0xCD))
        {
            colors=1<<header.bitperpix*header.planes;
            dib=(DIB *)malloc(sizeof(DIB)+colors*sizeof(RGBQUAD));
            if(dib)
            {
                memset(dib,0,sizeof(DIB));
                if(colors>0&&colors<=16)
                {
                    memcpy(dib->bmi.bmiColors,defaultPalette+(16-colors),colors*sizeof(RGBQUAD));
                    memcpy(dib->bmi.bmiColors,defaultPalette,1*sizeof(RGBQUAD));
                }
                dib->bmi.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
                dib->bmi.bmiHeader.biWidth=header.right-header.left+1;
                dib->bmi.bmiHeader.biHeight=header.bottom-header.top+1;
                dib->bmi.bmiHeader.biPlanes=1;
                dib->bmi.bmiHeader.biBitCount=header.bitperpix*header.planes;
                if(dib->bmi.bmiHeader.biBitCount<=1) dib->bmi.bmiHeader.biBitCount=1;
                else if(dib->bmi.bmiHeader.biBitCount<=4) dib->bmi.bmiHeader.biBitCount=4;
                else if(dib->bmi.bmiHeader.biBitCount<=8) dib->bmi.bmiHeader.biBitCount=8;
                else dib->bmi.bmiHeader.biBitCount=24;
                dib->bmi.bmiHeader.biCompression=BI_RGB;
                dib->bmi.bmiHeader.biClrUsed=colors;
                skew=((dib->bmi.bmiHeader.biWidth*dib->bmi.bmiHeader.biBitCount+31UL)/32UL)*4UL;
                dib->bmi.bmiHeader.biSizeImage=skew*dib->bmi.bmiHeader.biHeight;
                if((dib->data=GlobalLock(GlobalAlloc(GMEM_MOVEABLE|GMEM_ZEROINIT,dib->bmi.bmiHeader.biSizeImage)))!=NULL)
                {
                    count=0;
                    for(j=(int)dib->bmi.bmiHeader.biHeight;j-->0;)
                    {
                        for(n=0;n<header.planes;n++)
                        {
                            ptr=dib->data+skew*j;
                            if(colors==0) ptr+=3*(2-n);
                            for(i=0;i<header.skew;i++)
                            {
                                if(count==0)
                                {
                                    value=getc(f);
                                    if(header.encoding==1&&value>=192)
                                    {
                                        count=(value&0x3F)-1;
                                        value=getc(f);
                                    }
                                }
                                else count--;
                                if(colors>2&&colors<=16)
                                {
                                    *ptr++|=bits[n][(value>>6)&3];
                                    *ptr++|=bits[n][(value>>4)&3];
                                    *ptr++|=bits[n][(value>>2)&3];
                                    *ptr++|=bits[n][value&3];
                                }
                                else if(colors>16&&colors<256)
                                {
                                    if(value&0x80) *ptr|=mask[n];
                                    ptr++;
                                    if(value&0x40) *ptr|=mask[n];
                                    ptr++;
                                    if(value&0x20) *ptr|=mask[n];
                                    ptr++;
                                    if(value&0x10) *ptr|=mask[n];
                                    ptr++;
                                    if(value&0x08) *ptr|=mask[n];
                                    ptr++;
                                    if(value&0x04) *ptr|=mask[n];
                                    ptr++;
                                    if(value&0x02) *ptr|=mask[n];
                                    ptr++;
                                    if(value&0x01) *ptr|=mask[n];
                                    ptr++;
                                }
                                else
                                {
                                    *ptr=value;
                                    ptr+=header.planes;
                                }
                            }
                        }
                    }
                    if(colors>16&&getc(f)==12
                    || colors<=16&&header.version!=3&&fseek(f,16L,SEEK_SET)!=EOF)
                    {
                        for(i=0;i<colors;i++)
                        {
                            dib->bmi.bmiColors[i].rgbRed=getc(f);
                            dib->bmi.bmiColors[i].rgbGreen=getc(f);
                            dib->bmi.bmiColors[i].rgbBlue=getc(f);
                            dib->bmi.bmiColors[i].rgbReserved=0;
                        }
                    }
                }
                else
                {
                    free(dib);
                    dib=NULL;
                    message("GlobalAlloc failed");
                }
            }
            else message("malloc failed");
        }
        else message("Can not read");
        fclose(f);
    }
    else message("File not found");
    return dib;
}
